/// @cond EO_CXX_EO_IMPL

inline double elm::button::autorepeat_initial_timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_initial_timeout_get());
   return _tmp_ret;
}

inline void elm::button::autorepeat_initial_timeout_set(double t_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_button_autorepeat_initial_timeout_set(t_));
}

inline double elm::button::autorepeat_gap_timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_gap_timeout_get());
   return _tmp_ret;
}

inline void elm::button::autorepeat_gap_timeout_set(double t_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_button_autorepeat_gap_timeout_set(t_));
}

inline bool elm::button::autorepeat_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::button::autorepeat_set(bool on_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_button_autorepeat_set(::efl::eolian::to_c(on_)));
}

inline bool elm::button::admits_autorepeat_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_button_admits_autorepeat_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline double eo_cxx::elm::button::autorepeat_initial_timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_initial_timeout_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::button::autorepeat_initial_timeout_set(double t_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_button_autorepeat_initial_timeout_set(t_));
}

inline double eo_cxx::elm::button::autorepeat_gap_timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_gap_timeout_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::button::autorepeat_gap_timeout_set(double t_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_button_autorepeat_gap_timeout_set(t_));
}

inline bool eo_cxx::elm::button::autorepeat_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::button::autorepeat_set(bool on_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_button_autorepeat_set(::efl::eolian::to_c(on_)));
}

inline bool eo_cxx::elm::button::admits_autorepeat_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_button_admits_autorepeat_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::button::operator ::elm::button() const
{
   return *static_cast<::elm::button const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::button::operator ::elm::button&()
{
   return *static_cast<::elm::button*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::button::operator ::elm::button const&() const
{
   return *static_cast<::elm::button const*>(static_cast<void const*>(this));
}

template <typename T>
double elm_button_autorepeat_initial_timeout_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->autorepeat_initial_timeout_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_button_autorepeat_initial_timeout_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double t_)
{
   try
      {
         static_cast<T*>(self->this_)->autorepeat_initial_timeout_set(t_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_button_autorepeat_gap_timeout_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->autorepeat_gap_timeout_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_button_autorepeat_gap_timeout_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double t_)
{
   try
      {
         static_cast<T*>(self->this_)->autorepeat_gap_timeout_set(t_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_button_autorepeat_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->autorepeat_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_button_autorepeat_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool on_)
{
   try
      {
         static_cast<T*>(self->this_)->autorepeat_set(::efl::eolian::to_cxx<bool>(on_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_button_admits_autorepeat_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->admits_autorepeat_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::button >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual double autorepeat_initial_timeout_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_button_autorepeat_initial_timeout_get());
            return _tmp_ret;
      }

      virtual void autorepeat_initial_timeout_set(double t_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_button_autorepeat_initial_timeout_set(t_));
      }

      virtual double autorepeat_gap_timeout_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_button_autorepeat_gap_timeout_get());
            return _tmp_ret;
      }

      virtual void autorepeat_gap_timeout_set(double t_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_button_autorepeat_gap_timeout_set(t_));
      }

      virtual bool autorepeat_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_button_autorepeat_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void autorepeat_set(bool on_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_button_autorepeat_set(::efl::eolian::to_c(on_)));
      }

      virtual bool admits_autorepeat_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_button_admits_autorepeat_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::button >
{
   static constexpr int value = 
#if defined(BUTTON_PROTECTED) && defined(BUTTON_BETA)
      7
#elif defined(BUTTON_PROTECTED)
      7
#elif defined(BUTTON_BETA)
      7
#else
      7
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::evas::clickable_interface >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::button>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_button_autorepeat_initial_timeout_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_initial_timeout_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_button_autorepeat_initial_timeout_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_initial_timeout_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_button_autorepeat_gap_timeout_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_gap_timeout_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_button_autorepeat_gap_timeout_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_gap_timeout_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_button_autorepeat_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_button_autorepeat_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_button_admits_autorepeat_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_button_admits_autorepeat_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::button >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::button >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::button >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::evas::clickable_interface>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::button>)
{
   return (ELM_BUTTON_CLASS);
}

} } }

/// @endcond

